// pages/classTotalList/classTotalList.js
const app = getApp()
const util = require("../../utils/util")
const urlDef = require("../../utils/urls")
Page({

  /**
   * 页面的初始数据
   */
  data: {
    list: [],
    courseItems: [],
    moneyItems: [],
    loading: '上拉加载',
    flag: 0,
    pageNum: 0,
    hasNextPage: true,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.queryList()
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    if (this.data.hasNextPage) {
      let pn = this.data.pageNum
      this.setData({
        loading: '加载中',
        'pageNum': ++pn
      })
      this.queryList()
    }
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  queryList: function () {
    const urls = urlDef.urls;
    let stu = wx.getStorageSync('student')
    let params = {
      'q.studentId': stu.studentId,
      'q.orgId': stu.orgId
    }
    params.pageNum = this.data.pageNum
    util.apiPost(urls.get_course_report, params).then(rs => {
      let list = rs.list
      list.map(it => {
        let item = Object.assign({}, it);
        if (item.endDate) {
          item.endDate = item.endDate.substring(0, 10)
        }
        if (it.billingMethod === 'T' || it.billingMethod === 'P') {
          this.data.courseItems.push(item);
        } else if (it.billingMethod === 'M') {
          this.data.moneyItems.push(item);
        }
      })

      if (this.data.courseItems.length <= 0) {
        wx.showModal({
          title: '提示',
          content: '暂无数据',
          showCancel: false, //是否显示取消按钮
          cancelText: "否", //默认是“取消”
          cancelColor: '#999999', //取消文字的颜色
          confirmText: "确定", //默认是“确定”
          confirmColor: 'skyblue', //确定文字的颜色
          success(res){
            if(res.confirm){
              wx.navigateBack({
                delta: -1,
              })
            }
          }
        })
      }

      this.setData({
        'hasNextPage': rs.hasNextPage,
        'loading': rs.hasNextPage ? '下拉刷新' : '没有更多数据',
        'courseItems': this.data.courseItems,
        'moneyItems': this.data.moneyItems
      })
    })
  },
})